#include <string>
#include <admin>
#include <adminlib>

#define ACCESS_CONSOLE	131072

/************************Hier kann man die Werte editieren******************/
new g_warning=10;				//nach 10 Sekunden kommt eine Warnung
new g_slay_afk_camp=15;			//nach 15 Sekunden der slay
new g_kick=3;					//beim 4 slay kommt ein kick, wenn es kein Admin ist
/***************************************************************************/

new STRING_VERSION[MAX_DATA_LENGTH]="1.0";
new g_plugin=1;

new User_X[MAX_PLAYERS];
new User_Y[MAX_PLAYERS];
new User_Z[MAX_PLAYERS];
new User_Times[MAX_PLAYERS];
new User_Slayed[MAX_PLAYERS];



public plugin_init() {
	plugin_registerinfo("ANTI AFK PLUGIN","Slays and kicks afkler at startpoint",STRING_VERSION);
	plugin_registercmd("admin_afk","admin_afk",ACCESS_CONFIG,"admin_afk <0/1>: enable/disable plugin");
	if(!get_vaultnumdata("ADMIN_AFK",g_plugin)){
		g_plugin=1;
	}
	if(g_plugin){
		plugin_registercmd("afk_world","afk_world",ACCESS_CONSOLE);
		exec( "logd_reg 62 admin_command afk_world");	/*WORLD-EVENT*/	
		set_timer("check",1,99999);
	}	
	return PLUGIN_CONTINUE;
}

public admin_afk(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	g_plugin=strtonum(Data);
	set_vaultnumdata("ADMIN_AFK",g_plugin);
	snprintf(Data,MAX_DATA_LENGTH,"[AFK] Plugin is set to %i",g_plugin);
	selfmessage(Data);
	return PLUGIN_HANDLED;
}

public afk_world(HLCommand,HLData,HLUserName,UserIndex) {
	new Data[MAX_DATA_LENGTH];
	new i;
	new maxplayers=maxplayercount();
	new Player[MAX_NAME_LENGTH];
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	if(Data[0]=='G' || Data[8]=='R'){
		reset(0);
	}else if (Data[6]=='E'){
		reset(0);
	}else if (Data[6]=='S'){
		for(i=1;i<=maxplayers;i++){
			if(playerinfo(i,Player,MAX_NAME_LENGTH)){
				get_userorigin(Player,User_X[i],User_Y[i],User_Z[i]);
			}
		}
	}
	return PLUGIN_CONTINUE;
}

public check(Timer,Repeat,HLName,HLParam) {
	new i;
	new maxplayers=maxplayercount();
	new Data[MAX_DATA_LENGTH];
	new Player[MAX_NAME_LENGTH];
	new X;
	new Y;
	new Z;
	new iTeam;
	new iDead;

	for(i=1;i<=maxplayers;i++){
		if(playerinfo(i,Player,MAX_NAME_LENGTH,_,_,iTeam,iDead)){
			if(!iDead && iTeam <= 2){
				get_userorigin(Player,X,Y,Z);
				if(User_X[i]==X && User_Y[i]==Y && User_Z[i]==Z){
					User_Times[i]+=1;
				}
				if(User_Times[i]>=g_slay_afk_camp){
					slay(Player);
					reset(i);
					User_Slayed[i]+=1;
					if(User_Slayed[i]>g_kick){
						if(!check_immunity(Player)){
							reset(i,1);
							kick(Player);
						}
					}
					snprintf(Data,MAX_DATA_LENGTH,"%s is slayed^nwhile camping/being afk!!!!",Player);
					centersay(Data,20,255,0,0);
				}

				if(User_Times[i]==g_warning){
					snprintf(Data,MAX_DATA_LENGTH,"%s, don't camp....^nPlease move or u will be slayed!!!",Player);
					centersayex(Player,Data,10,255,0,0);
				}
			}
		}
	}
}

public plugin_disconnect(HLUserName,UserIndex) {
	if(g_plugin){
		reset(UserIndex,1);
	}
	return PLUGIN_CONTINUE;
}
	
public plugin_connect(HLUserName,HLIP, UserIndex) {
	if(g_plugin){
		reset(UserIndex,1);
	}
	return PLUGIN_CONTINUE;
}

reset(UserIndex,ID=0){
	new i;
	new maxplayers=maxplayercount();
	if(!UserIndex){
		for(i=1;i<=maxplayers;i++){
			User_Times[i]=0;
			User_X[i]=0;
			User_Y[i]=0;
			User_Z[i]=0;
			User_Slayed[UserIndex]=0;
		}
	}else{
		User_Times[UserIndex]=0;
		User_X[UserIndex]=0;
		User_Y[UserIndex]=0;
		User_Z[UserIndex]=0;
		if(ID){
			User_Slayed[UserIndex]=0;
		}
	}
}
	